#include "math.h"

#define MAX(a, b)  (((a) > (b)) ? (a) : (b))
#define MIN(a, b)  (((a) < (b)) ? (a) : (b))
#define UNDEFINED (0.0F)
#define BACKGROUND 255
#define FOREGROUND 0
#define BPP 3
#define MAX_BLOB 1000

//ȭ  ü
typedef struct {
	int y,x; //ǥ 
} StructureElementBinary,*pStructureElementBinary;


//   ü
#define MAXPOLY 1000
#define EPSILON 0

typedef struct {
	double x;
	double y;
} point;

typedef struct{
	int n;
	point p[MAXPOLY];
}polygon;


typedef struct {
		float f_inter;
		int   poly_index;
}inter_struct;

extern void convert_gray(ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize,  int ysize);
extern void m_RGB2HSI   (ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize, int ysize,int low_h_down,int low_h_up,int high_h_down,int high_h_up);
extern void RGB_To_HSI(float r, float g, float b, float *h, float *s, float *i);
extern void RGB_To_YCbCr   (ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize, int ysize,int low_y_down,int low_y_up,int high_y_down,int high_y_up);
extern void init_image(ARUint8   *dataPtr,int xsize,int ysize,int data);
extern void image_copy(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize);
extern void rgb_segment   (ARUint8  *dataPtr,   ARUint8 outPtr[], int xsize, int ysize,int r_max,int g_max,int b_max,int all_max);

//󺧸
extern int m_BlobColoring(ARUint8   *dataPtr,ARUint8   *outPtr,int width,int height);
//ħ
extern void m_MorphologyBinaryErosion(ARUint8   *dataPtr,ARUint8   *outPtr,int xsize, int ysize);
//â
extern void m_MorphologyBinaryDilation(ARUint8   *dataPtr,ARUint8   *outPtr,int xsize, int ysize);
//ȸ
extern void mask_processing(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize,int mask_size,int MaskBox[3][3]);
//1
extern void init_binary(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize,int data);

// 
extern void convex_hull(point in[],int n,polygon *hull,int range,point center);
//ȼ ǥ -  ϱ   Ʈ ˻
extern void search_point(ARUint8   *dataPtr,int xsize,int ysize,point in[],int *input_count);

//߽
extern void get_center(ARUint8   *dataPtr,int xsize,int ysize,int *center_x,int *center_y,int data);

//Ƽؽ
extern void MSRCR(ARUint8 *src,int width,int height,int bytes);
//2  Ÿ
extern double distance(point p1, point p2);

//ȭ
extern void m_Thinning(ARUint8   *dataPtr,ARUint8 outPtr[],int xsize,int ysize);

//Ʈ compareԼ - max  Ҷ δ
extern int inter_func(const void *com1,const void *com2);

extern bool ccw(point a,point b, point c);

//̹ ũ⺯
extern void resize_image(ARUint8   *dataPtr,ARUint8   *outPtr,int xsize,int ysize,float x_scale,float y_scale);
