#ifdef _WIN32
//#include <windows.h>
#endif

//#include <stdio.h>
#include <stdlib.h>


#ifndef __APPLE__
//#include <GL/gl.h>
#include <GL/glut.h>
//#else
//#include <OpenGL/gl.h>
//#include <GLUT/glut.h>
#endif
#include <AR/gsub.h>
#include <AR/video.h>
//#include <AR/param.h>
//#include <AR/ar.h>

#include <string.h>


#include "mix.h"
#include "md2loader.h"
#include "texture.h"
#include "image_process.h"//ó ҽ ش

//
// Camera configuration.
//
#ifdef _WIN32
char   *vconf = "Data\\WDM_camera_flipV.xml";//init camera  ö  
#else
char   *vconf = "";
#endif



//multi pattern.
//ϴ ŭ obj pattern   ִ.  츮 Ʈ 
// ⼭ "Data/point.patt"   Ѵ.   mk_patt util   ִ.

#define  MARKER_NUM        2

#define  OBJ1_PATT_NAME    "Data/m1.patt"
#define  OBJ2_PATT_NAME    "Data/m2.patt"

#define  OBJ1_MODEL_ID      1
#define  OBJ2_MODEL_ID      2

#define  OBJ1_SIZE         80.0
#define  OBJ2_SIZE         80.0

#define MAX_FRAME_COUNT 30




// ============================================================================
//                           
// ============================================================================

int             xsize, ysize;//ī޶ width, height
int             thresh = 100;//arDetectMarker Ӱ谪
int             count = 0;   //frame/sec
int				finger_count;

char           *cparam_name    = "Data/camera_para.dat";
ARParam         cparam;

static int view_mode; //  image 

ARUint8         *dataPtr;//Է ̹ Ű 
ARUint8         *bigPtr;//Է ̹ Ű 

//  object id
//ʴ ޴  ̴. Ű带 2  ŷ .. ڿ  ϳ Ŀ ٸ Ʈ 
int current_object_id=0;

int frame_count=0;//next image 30 ̻ ġ, Ʈ ׸ ʴ´. 
//  Ŀ ĵ  ġ   ϴµ Ѵ.

typedef struct {
	char    *patt_name;
	int     patt_id;
	int     model_id;
	int     visible;
	double  width;
	double  center[2];

	bool    b_first;// Ŀ νϱ  ׷ ȵȴ.
	float   x;//Ʈ ġ
	float   y;
	float   z;

	double  trans[3][4];
	double oldtrans[3][4];

} OBJECT_T;


// 4 Ŀ νϰ Ǿִ.
// ߰  ִ.
OBJECT_T   object[MARKER_NUM] = {
	{OBJ1_PATT_NAME, -1, OBJ1_MODEL_ID, 0, OBJ1_SIZE, {0.0,0.0},true,0,0,0},
	{OBJ2_PATT_NAME, -1, OBJ2_MODEL_ID, 0, OBJ2_SIZE, {0.0,0.0},true,0,0,0}	
};


bool debug_opengl=false;
static bool retinex_on=false;
//ؽ 
GLuint texture[8];

static float X_SCALE = 1;
static float Y_SCALE = 1;


//  HSI 
static int low_h_down=0,low_h_up=28,high_h_down=332,high_h_up=360;
//  YCbCr 
static int low_y_down=77,low_y_up=127,high_y_down=133,high_y_up=173;
//rgb
static int r_max=95,g_max=40,b_max=20,all_max=15;


// ============================================================================
//                          Լ 
// ============================================================================

static void   init(void);
static void   cleanup(void);
static void   keyEvent( unsigned char key, int x, int y);
static void   mainLoop(void);
static void   draw( int object, double trans[3][4],ARUint8 * blob_image,point click,int count,int max_blob);
static void cleanup(void);


// ============================================================================
//          main 
// model3D.Load 3d Ʈ ҷ´.    ϴ.
// ============================================================================
int main(int argc, char **argv)
{
	float size;	
	atexit(cleanup);

	glutInit( &argc, argv);//Glut ̺귯 ʱȭ  ü   	

	//Mode Select
	printf("\n*** Image select ***\n");
	printf("1. Normal 2.hsi 3. ycbcr 4. rgb_segment 5.Convert 6.Erosion 7.Dilation 8.Label 9.Counter \n");
	fflush(stdin);
	scanf("%d",&view_mode);
	printf("TIP : 'q','w','e','r','t','y','u',i','o' is image change key\n");		
	printf("TIP : '0' - debug   on/off \n");
	printf("TIP : '9' - retinex on/off \n");

	printf("\n*** select window scale ***\n");
	do{
		printf("input 1.0 ~ 3.0 \n:");
		fflush(stdin);
		scanf("%f",&size);		
	}while(size<1 || size>3);
	X_SCALE = Y_SCALE = size;

	init();				   //camera  ʱȭ	
	arVideoCapStart();     //v4l ̿ capture 	

	LoadGLTextures(texture);      //ؽĸ εѴ.	

	argMainLoop( NULL, keyEvent, mainLoop ); 
	
	return (0);
}


// ============================================================================
//        keyEvent
// - Ű ̺Ʈ  Ʈ δ. ex) qwaszx  , q · ̵
// - Ű ̺Ʈ ڿ  ٸ Ʈ ׸. ex) 1 - ޴ , 2 - ŷ
// ============================================================================

static void   keyEvent( unsigned char key, int x, int y)
{	
	/* quit if the ESC key is pressed */
	if( key == 0x1b ) {
		printf("*** %f (frame/sec)\n", (double)count/arUtilTimer());
		cleanup();
		exit(0);
	}	
	//ǾƳ 	
	if((key-'0') == 1){printf("Do\n");mix(0);}//
	else if((key-'0') == 2){printf("RE\n");mix(1);}//
	else if((key-'0') == 3){printf("ME\n");mix(2);}//
	else if((key-'0') == 4){printf("PA\n");mix(3);}//
	else if((key-'0') == 5){printf("SOL\n");mix(4);}//
	else if((key-'0') == 6){printf("RA\n");mix(5);}//
	else if((key-'0') == 7){printf("SI\n");mix(6);}//
	else if((key-'0') == 8){printf("Do\n");mix(7);}//


	else if((key-'0') == 0)debug_opengl=!debug_opengl;
	else if((key-'0') == 9){
		retinex_on=!retinex_on;
		if(retinex_on == true)
			printf("retinex on\n");
		else
			printf("retinex off\n");
	}
	


	//view mode change
	//printf("1. Normal 2.hsi 3. ycbcr 4. rgb_segment 5.Convert 6.Erosion 7.Dilation 8.Label 9.Counter \n");
	if( key == 'q' || key == 'Q'){printf("Normal\n");view_mode=1;}
	else if( key == 'w' || key == 'W' ){printf("hsi\n");view_mode=2;}
	else if( key == 'e' || key == 'E'){printf("ycbcr\n");view_mode=3;}
	else if( key == 'r' || key == 'R'){printf("rgb_segment\n");view_mode=4;}	
	else if( key == 't' || key == 'T' ){printf("Convert\n");view_mode=5;}
	else if( key == 'y' || key == 'Y' ){printf("Erosion\n");view_mode=6;}
	else if( key == 'u' || key == 'U'){printf("Dilation\n");view_mode=7;}
	else if( key == 'i' || key == 'I'){printf("Label\n");view_mode=8;}	
	else if( key == 'o' || key == 'O'){printf("Counter\n");view_mode=9;}
	
	

	//object change-  	
	else if( key >= '0' && key <= '10'){
		current_object_id=key-'0';
	}	
	//printf("key=%c\n",key);

	if( view_mode==2){	
		if(key == 'a' || key =='A')		low_h_down--;
		else if(key == 's' || key =='S')low_h_down++;
		else if(key == 'd' || key =='D')low_h_up--;
		else if(key == 'f' || key =='f')low_h_up++;
		else if(key == 'z' || key =='Z')high_h_down--;
		else if(key == 'x' || key =='X')high_h_down++;
		else if(key == 'c' || key =='C')high_h_up--;
		else if(key == 'v' || key =='V')high_h_up++;

		printf("before\n");
		printf("0~28,332~360\n");
		printf("after\n");
		printf("%d~%d,%d~%d\n",low_h_down,low_h_up,high_h_down,high_h_up);
		
	}
	else if( view_mode==3){	
		if(key == 'a' || key =='A')		low_y_down--;
		else if(key == 's' || key =='S')low_y_down++;
		else if(key == 'd' || key =='D')low_y_up--;
		else if(key == 'f' || key =='f')low_y_up++;
		else if(key == 'z' || key =='Z')high_y_down--;
		else if(key == 'x' || key =='X')high_y_down++;
		else if(key == 'c' || key =='C')high_y_up--;
		else if(key == 'v' || key =='V')high_y_up++;

		printf("before\n");
		printf("77~127,133~173\n");
		printf("after\n");		
		printf("%d~%d,%d~%d\n",low_y_down,low_y_up,high_y_down,high_y_up);
	}	
	else if( view_mode==4){	
		if(key == 'a' || key =='A')		r_max--;
		else if(key == 's' || key =='S')r_max++;
		else if(key == 'd' || key =='D')g_max--;
		else if(key == 'f' || key =='f')g_max++;
		else if(key == 'z' || key =='Z')b_max--;
		else if(key == 'x' || key =='X')b_max++;
		else if(key == 'c' || key =='C')all_max--;
		else if(key == 'v' || key =='V')all_max++;

		printf("before\n");
		printf("95,40,20,15\n");
		printf("after\n");		
		printf("%d,%d,%d,%d\n",r_max,g_max,b_max,all_max);
	}	
	
}


// ============================================================================
//        init
// - ī޶  ʱȭ 
// - window ʱȭ
// - pattern read
// ============================================================================
static void init( void )
{
	ARParam  wparam;
	int      i;

	/* open the video path */
	//if( arVideoOpen( vconf ) < 0 ) exit(0);//ī޶  а ʱȭѴ.(width,height)	
	if( arVideoOpen( NULL ) < 0 ) exit(0);//ī޶  а ʱȭѴ.(width,height)			

	/* find the size of the window */
	if( arVideoInqSize(&xsize, &ysize) < 0 ) exit(0);// â ʱȭѴ.(width,height)
	printf("Image size (x,y) = (%d,%d)\n", xsize, ysize);

	//xsize=640;
	//ysize=480;

	int xsize2=xsize * X_SCALE,ysize2=ysize*Y_SCALE;


	/* set the initial camera parameters */
	//camera_para д´. ƿ α׷ Ŀ νĽŰ,   ִ.
	if( arParamLoad(cparam_name, 1, &wparam) < 0 ) {
		printf("Camera parameter load error !!\n");
		exit(0);
	}
	arParamChangeSize( &wparam, xsize2, ysize2, &cparam );//ar 밡ϰ param ٲ۰ Ѵ.
	arInitCparam( &cparam );
	printf("*** Camera Parameter ***\n");
	arParamDisp( &cparam );

	/////////////Ƽ  /////////////////
	//mk_patt   εϿ, id Ѵ.
	for( i = 0; i < MARKER_NUM ; i++ ) {
		if( (object[i].patt_id=arLoadPatt(object[i].patt_name)) < 0 ) {
			printf("pattern load error: %s\n", object[i].patt_name);
			exit(0);
		}  
	}	
	/* open the graphics window */
	argInit( &cparam, 1.0, 0, 0, 0, 0 );

	//////////////md2load///////////////////////
	md2load("./Data/character/garfield/tris.md2");

	//SDL _ Sound Init
	mix_init();
}

// ============================================================================
//        cleanup
// - cleanup function called when program exits
// ============================================================================
static void cleanup(void)
{
	//	FreeModel (&md2file);
	//mix_clean_up();
	arVideoCapStop();
	arVideoClose();
	argCleanup();		
}

// ============================================================================
//        drawText
// - ϴ text   ִ.
// ============================================================================
void drawText(int x, int y, char* text) {

	int length = strlen(text) + 1;
	glColor3f(0.0,0.0,0.0);
	for(int i=0; i<length; i++) {
		glRasterPos2i( x, y);
		glutBitmapCharacter(GLUT_BITMAP_9_BY_15, text[i]);		
		x+=glutBitmapWidth(GLUT_BITMAP_9_BY_15, text[i]);
	}
	
	//glutSwapBuffers();
}

void displayString(char string[], float r, float g, float b, int cx, int y)
{
        glColor3f(r, g, b); // our fonts color

        /* think of the following this way:
         * our center x is x.
         * take the length of our string and * by 9 for the char width
         * and thats how wide in pixels the resulting thing will be.
         * right?
         * now, divide that by 2 to center it
         */
        int x = cx - ((strlen(string) * 9) / 2);
        y = y - 7; // y - ~(15 / 2). id rather not use float, so 7 isn't too diff than 7.5

        for(unsigned int i = 0; i != strlen(string) - 1; ++i)
        {
                glRasterPos3f(x, y, 0);
                glutBitmapCharacter(GLUT_BITMAP_9_BY_15, string[i]);
                x = x + 9; // accomidate for the next letter
        }
}


// ============================================================================
//         main loop
// ============================================================================

static void mainLoop(void)
{
	ARMarkerInfo    *marker_info;
	int             marker_num;
	int             j, k,i,x,y;
	int max_blob;//labeling ִ 

	// ߽	
	int center_x=0; int center_y=0;	

	//  ߽
	int center_x2=0;int center_y2=0;	

	//  ϱ  
	// ִ   Ѱ   point ãµ  ش.
	int x1,y1,x2,y2;	

	//ճ ǥ
	point click;

	//ճ Ʈ 
	int max_index=0;

	//image size
	static unsigned long image_size=xsize*ysize*BPP;

	// 
	static polygon poly;

	/* grab a video frame */
	if( (dataPtr = (ARUint8 *)arVideoGetImage()) == NULL ) {
		arUtilSleep(2);
		return;
	}

	if( count == 0 ) arUtilTimerReset();
	count++;
	///////////////////////////// Image Processing /////////////////////////////////////
	//4ä BGRA  	
	//int MaskBox[3][3]={{-1,-1,-1},{-1,8,-1},{-1,-1,-1}};//öþ 2̺  ΰ	
	//int sobelx_mask[3][3]={{-1,0,1},{-2,0,2},{-1,0,1}};//Һ x
	//int sobely_mask[3][3]={{-1,-2,-1},{0,0,0},{1,2,1}};//Һ y 
	//int MaskBox[3][3]={{-1,0,1},{-1,0,1},{-1,0,1}};//Prewitt-X
	//int MaskBox[3][3]={{-1,-1,-1},{0,0,0},{1,1,1}};//Prewitt-Y 
	//int MaskBox[3][3]={{1,1,1},{1,1,1},{1,1,1}};// Ȱȭ	

	ARUint8 *hsi_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 		
	ARUint8 *ycbcr_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 		
	ARUint8 *rgb_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 		
	ARUint8 *color_or_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 	
	ARUint8 *blob_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 
	ARUint8 *blob_image2=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 
	ARUint8 *contour_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size); 	
	//memset(contour_image,0,image_size);
	ARUint8 *erosion_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size);
	ARUint8 *dilation_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size);	

	ARUint8 *extension_image=(ARUint8 *)malloc(sizeof(ARUint8)*xsize*X_SCALE*ysize*Y_SCALE*BPP);	

	point *input = (point *)malloc(sizeof(point)*xsize*ysize*BPP);
	inter_struct *inter;
	

	// ******************** 0. Retinex            ********************
	if(retinex_on==true){
		ARUint8 *retinex_image=(ARUint8 *)malloc(sizeof(ARUint8)*image_size);
		memcpy(retinex_image,dataPtr,image_size);	
		MSRCR(retinex_image,xsize,ysize,BPP);
		memcpy(dataPtr,retinex_image,image_size);		
		free(retinex_image);		
	}

	// ******************** 1. skin color detect  ********************

	//(0<h && h<28) || (332<h && h<360)	
	m_RGB2HSI   (dataPtr,hsi_image,  xsize,ysize,low_h_down,low_h_up,high_h_down,high_h_up);// ѹ Ѵ//Ʈ  Ѵ. 				
	RGB_To_YCbCr(dataPtr,ycbcr_image,xsize,ysize,low_y_down,low_y_up,high_y_down,high_y_up);
	rgb_segment(dataPtr,rgb_image,xsize,ysize,r_max,g_max,b_max,all_max);	

	//hsi + ycbcr + rgb skin color ã´.
	for(i=0;i<image_size;i+=BPP){
		if(hsi_image[i]==0 || ycbcr_image[i]==0 || rgb_image[i]==0){
			color_or_image[i]=0;
			color_or_image[i+1]=0;
			color_or_image[i+2]=0;
		}
		else{
			color_or_image[i]=255;
			color_or_image[i+1]=255;
			color_or_image[i+2]=255;
		}
	}
	
	

	// ******************** 2. Morphology       ********************
	m_MorphologyBinaryErosion(color_or_image,erosion_image,xsize,ysize);//ħ
	m_MorphologyBinaryDilation(erosion_image,dilation_image,xsize,ysize);//â


	// ******************** 3.1 Labeling         ********************
	max_blob=m_BlobColoring(dilation_image,blob_image,xsize,ysize); //max_blob 󺧸 	


	if(max_blob>=MAX_BLOB){		

		// ******************** 3.2 contour          ********************	
		//Ȯ      Ѵ.

		m_MorphologyBinaryDilation(blob_image,blob_image2,xsize,ysize);

		for(i=0;i<image_size;i+=BPP){
			if(blob_image[i]==255 && blob_image2[i]==0){
				contour_image[i]=0;
				contour_image[i+1]=0;
				contour_image[i+2]=0;
			}else{
				contour_image[i]=255;
				contour_image[i+1]=255;
				contour_image[i+2]=255;
			}
		}

		// ******************** 3.3  ߽        ********************
		// հ   
		//  ߽  ߽ɺ ׻  ִ.	


		//  
		point center;
		//  0 count  pixel  object  
		//ƴ  ֱ⶧ 
		get_center(blob_image,xsize,ysize,&center_x,&center_y,0);	
		// 	
		get_center(contour_image,xsize,ysize,&center_x2,&center_y2,0);	


		// ******************** 3.4          ********************
		//  ϱ  Һ ̹  ġ input迭 ִ´.	
		//input ḮƮ  ʿ伺 ִ.
		int input_count=0;

		for(y=0;y<ysize;y++){
			for(x=0;x<xsize;x++)		{			
				if(contour_image[y*xsize*BPP+BPP*x]==0){				
					input[input_count].x=x;
					input[input_count++].y=ysize-y;		
					if(input_count == 10000){
						input_count=9999;
						break;
					}
				}
			}
		}

		center.x = center_x;
		center.y = center_y;
		convex_hull(input,input_count,&poly,50,center);			


		//   	

		//printf("\n\n   \n");	
		//for(i=0;i<poly.n;i++){
		//printf("%f %f\n",poly.p[i].x,poly.p[i].y);
		//}

		// ******************** 3.5  ճ ǥ   ********************

		// ͸ ϰ   ϸ,    ū  ´. 
		//  +1 ~ -1   ̴.
		// cos@ = (x1*x2 + y1*y2) / (sqrt(x*x+y*y) * sqrt(x2*x2+y2*y2))
		// ׷ 츮  Ͽ cos@ ϴ  ƴ϶, 3  ϱ⶧
		//   Ѵ.   ǥ ߽ǥ  ٱ ǥ.
		//
		//                    *  center_x2,center_y2
		//                   /
		//                  /
		//                 /
		//  obj.x,y       /
		//   *-----------* center_x,center_y


		x1=center_x2 - center_x;//x1,y1      
		y1=center_y2 - center_y;

		// ū   ƮϿ inter ü .
		//interü  װͿ ϴ poly ε  ̴.
		inter=(inter_struct *)malloc(sizeof(inter_struct)*poly.n);

		for(i=0;i<poly.n;i++){
			x2=poly.p[i].x - center_x;//x2,y2       
			y2=poly.p[i].y - center_y;   
			inter[i].f_inter=(x1*x2 + y1*y2) /( sqrt((double)(x1*x1+y1*y1)) * sqrt((double)(x2*x2+y2*y2)));
			inter[i].poly_index = i;
		}	

		// ū  Ѵ. -  Ŭ  finger point Ȯ ũ.
		qsort(inter,poly.n,sizeof(inter_struct),inter_func);	

		//    Ѵ.
		//printf("after quick sort\n");
		//for(i=0;i<poly.n;i++){
		//	printf("%f   %d\n",inter[i].f_inter,inter[i].poly_index);		
		//}	


		//ճ Ʈ 	
		if(poly.n>1){
			// y    -  հ  ϴ  
			//õ 2 ߿ y Ϳ 켱 ش.
			if(center_y2 > center_y){						
				if(poly.p[ inter[0].poly_index ].y > poly.p[ inter[1].poly_index ].y)
					max_index = 	inter[0].poly_index; 		
				else
					max_index = 	inter[1].poly_index; 
			}
			// x  x Ŭ
			else if(center_x2 > center_x){
				//printf(" x >  x\n");
				if(poly.p[ inter[0].poly_index ].x > poly.p[ inter[1].poly_index ].x)
					max_index = 	inter[0].poly_index; 		
				else
					max_index = 	inter[1].poly_index;				
			}
			else{// ͵ ƴϸ   ū point Ѵ.			
				max_index = 	inter[0].poly_index; 				
			}
		}

		//click ǥ			
		if(poly.n>0){		
			click.x = poly.p[max_index].x;
			click.y  =poly.p[max_index].y;
		}
		free(inter);


		//////////////////// 3.6  ׷ հ  ˾ ////////	

		int rad=0, angle=0;	
		rad = 10; // 

		float xx=0,yy=0;
		int flag=0;

		// -  ̶ Ǵ  3/5 
		if(poly.n>1)
			rad = distance(poly.p[max_index],center) * 2/3;

		x1=center_x2 - center_x;//x1,y1      
		y1=center_y2 - center_y;

		finger_count=0;
		flag=0;
		int white_count=0;
		int black_count=0;
		for(angle=0; angle <360; angle ++){			
			xx= cos(angle* 3.14/180) *rad  + center_x;
			yy= -sin(angle *3.14/180) *rad + center_y;
			//x,yǥ ÷   ߺ  Ͼ.
			x = (int)xx;
			y = (int)yy;	

			x2=x - center_x;//x2,y2       
			y2=y - center_y;  

			//Ÿ  ׷ հ  .
			//ո üũ ʱ   Ѵ.
			//0̻ ϸ  ⿡ 180ϸ ׷ üũ Ѵ.			
			//üũѴ.
			if((x1*x2 + y1*y2) /( sqrt((double)(x1*x1+y1*y1)) * sqrt((double)(x2*x2+y2*y2))) > -0.2){
				if(x>0 && x<xsize && y>0 && y<ysize){
					if(debug_opengl==true){
						dataPtr[(ysize-y)*xsize*BPP+x*BPP]=255;	
						dataPtr[(ysize-y)*xsize*BPP+x*BPP+1]=255;
						dataPtr[(ysize-y)*xsize*BPP+x*BPP+2]=0;	
					}		

					//̸ ʱȭ
					if(  blob_image[(ysize-y)*xsize*BPP+x*BPP]==255){						
						flag=1;								
					}

					//  count++
					else if(flag==1 && blob_image[(ysize-y)*xsize*BPP+x*BPP]==0)
					{											
						black_count++;
						if(black_count==3){
							flag=0;
							black_count=0;
							if(finger_count<6)
								finger_count++;
						}						
					}
				}
			}
		}				
	}

	//printf("հ = %d\n",finger_count);

	// ******************** 4. Image Draw       ********************
	// Էߴ mode  ϴ ̹ ȭ鿡 ش.	


	//printf("1. Normal 2.Convert 3.Erosion 4.Dilation 5.Label 6.Counter 7.Retinex\n");

	

	


	/////////////////////////////////////̹ Ȯ////////////////////////////////////
	//printf("1. Normal 2.hsi . ycbcr 4. rgb_segment 5.Convert 6.Erosion 7.Dilation 8.Label 9.Counter \n");
	

	argDrawMode2D(); 
	if(view_mode==1){
		resize_image(dataPtr,extension_image,xsize,ysize,X_SCALE,Y_SCALE);		
		argDispImage(extension_image, 0,0 );			
	}
	else if(view_mode==2){
		resize_image(hsi_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );	
	}
	else if(view_mode==3){
		resize_image(ycbcr_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );	
	}
	else if(view_mode==4){
		resize_image(rgb_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );	
	}
	else if(view_mode==5){
		resize_image(color_or_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );	
	}	
	else if(view_mode==6){
		resize_image(erosion_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );	
	}
	else if(view_mode==7){
		resize_image(dilation_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );				
	}
	else if(view_mode==8){
		resize_image(blob_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );						
	}
	else if(view_mode==9){
		resize_image(contour_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
		argDispImage(extension_image, 0,0 );						
	}	
	else{
		resize_image(dataPtr,extension_image,xsize,ysize,X_SCALE,Y_SCALE);		
		argDispImage(extension_image, 0,0 );	
	}
	dataPtr=extension_image;
		
		

	// ******************** 5.  Draw Line       ********************

	if(max_blob>MAX_BLOB && debug_opengl==true){
		// OpenGl   ׸
		GLfloat sizes[2];//sizes[0] ּ  sizes[1] ִ
		glGetFloatv(GL_LINE_WIDTH_RANGE,sizes); // line β ´.
		GLfloat lineWidth=sizes[0];//ּҶ 
		glMatrixMode(GL_MODELVIEW);//ǥ 
		glLoadIdentity();//  ķ Ŭ
		glLineWidth(lineWidth+3);
		glColor3f(1.0f,0.0f,0.0f);

		//convex hull draw		
		glBegin(GL_LINE_LOOP);  
		for(i=0;i<poly.n;i++)				
			glVertex3f(poly.p[i].x * X_SCALE,poly.p[i].y * Y_SCALE,0.0f);		
		glEnd();
/*
		//  ߽
		glColor3f(0.0f,0.0f,1.0f);	
		glBegin(GL_LINES);  
		glVertex2f(0.0f,0.0f);
		glVertex2f(center_x * X_SCALE,center_y * Y_SCALE);		
		glEnd();

		//  ߽
		glColor3f(0.0f,1.0f,0.0f);	
		glBegin(GL_LINES);  
		glVertex2f(0.0f,0.0f);
		glVertex2f(center_x2 * X_SCALE,center_y2 * Y_SCALE);		
		glEnd();

		//  ū κ
		if(poly.n>0){
			glColor3f(1.0f,1.0f,0.0f);	
			glBegin(GL_LINES);  
			glVertex2f(0.0f,0.0f);
			glVertex2f(poly.p[max_index].x * X_SCALE,poly.p[max_index].y * Y_SCALE);		
			glEnd();
		}					
*/
	}	

	glMatrixMode(GL_MODELVIEW);//ǥ 
	glLoadIdentity();//  ķ Ŭ


	/////////////////////////////////    UI   	/////////////////////////////////
	///////////////////////////////// ϴ ޴	/////////////////////////////////
	glColor3f(0.9,0.9,0);
	glBegin(GL_POLYGON);      
	    glVertex2d(0,0);   
		glVertex2d(xsize*X_SCALE*1/3,0);
		glVertex2d(xsize*X_SCALE*1/3,15);
		glVertex2d(0,15);
    glEnd();           
	glColor3f(0.6,0.9,0.6);
	glBegin(GL_POLYGON);      
	    glVertex2d(xsize*X_SCALE*1/3,0);   
		glVertex2d(xsize*X_SCALE*2/3,0);
		glVertex2d(xsize*X_SCALE*2/3,15);
		glVertex2d(xsize*X_SCALE*1/3,15);
    glEnd();         
	glColor3f(0.7,0.7,0.9);
	glBegin(GL_POLYGON);      
	    glVertex2d(xsize*X_SCALE*2/3,0);   
		glVertex2d(xsize*X_SCALE,0);
		glVertex2d(xsize*X_SCALE,15);
		glVertex2d(xsize*X_SCALE*2/3,15);
    glEnd();           
//printf("1. Normal 2.hsi . ycbcr 4. rgb_segment 5.Convert 6.Erosion 7.Dilation 8.Label 9.Counter \n");
	if( view_mode==1)	  {displayString("Normal   "  ,0,0,0,  60*X_SCALE,10);}
	else if( view_mode==2){displayString("hsi  "      ,0,0,0,  60*X_SCALE,10);}
	else if( view_mode==3){displayString("ycbcr  "    ,0,0,0,  60*X_SCALE,10);}
	else if( view_mode==4){displayString("rgb_segment",0,0,0,  60*X_SCALE,10);}	
	else if( view_mode==5){displayString("Convert    ",0,0,0,  60*X_SCALE,10);}
	else if( view_mode==6){displayString("Erosion  "  ,0,0,0,  60*X_SCALE,10);}
	else if( view_mode==7){displayString("Dilation  " ,0,0,0,  60*X_SCALE,10);}
	else if( view_mode==8){displayString("Label  "    ,0,0,0,  60*X_SCALE,10);}
	else if( view_mode==9){displayString("Contour  "  ,0,0,0,  60*X_SCALE,10);}

	if(retinex_on == true){
		displayString("Retinex: ",0,0,0, 150*X_SCALE,10); 
		displayString("On  ",     0,0,1, 150*X_SCALE+50,10); 	
	}
	else{
		displayString("Retinex: ",0,0,0, 150*X_SCALE,10);
		displayString("OFF "   ,  1,0,0, 150*X_SCALE+50,10);
		
	}

	if(debug_opengl == true){
		displayString("Debug: ",0,0,0,  260*X_SCALE,10); 
		displayString("ON  ",   0,0,1,  260*X_SCALE+40,10); 		
	}
	else{
		displayString("Debug: ",0,0,0,  260*X_SCALE,10);
		displayString("OFF ",   1,0,0,  260*X_SCALE+40,10); 		
	}	


	// ******************** 6. detect the markers  ********************
	// detect the markers in the video frame 

	if( arDetectMarker(dataPtr, thresh, &marker_info, &marker_num) < 0 ) {  		
		cleanup();
		exit(0);
	} 


	//  ̹ ´. 
	arVideoCapNext(); 
	frame_count++;

	argDrawMode3D();
	argDraw3dCamera( 0, 0 );
	glClearDepth( 1.0 );
	glClear(GL_DEPTH_BUFFER_BIT);


	// ******************** 7. multy pattern detecte ********************	

	/* check for object visibility */
	for( i = 0; i < MARKER_NUM; i++ ) {
		k = -1;
		for( j = 0; j < marker_num; j++ ) {
			if( object[i].patt_id == marker_info[j].id ) {
				if( k == -1 ) k = j;
				else if( marker_info[k].cf < marker_info[j].cf ) k = j;// ġϴ ĿŽ
			}
		}
		object[i].visible = k;

		if( k >= 0) {
			// 鸲 
			//arGetTransMat(&marker_info[k],object[i].center, object[i].width,object[i].trans);
			//丮 ؼ 鸲 
			arGetTransMatCont(&marker_info[k], object[i].trans, object[i].center, object[i].width, object[i].trans); 

			//ó Ÿ Ŷ  ġ Ѵ
			//̰ Ŀ Ŀ  . ֱ    ֵ ϴµ δ.
			for(int y_line=0;y_line<3;y_line++)
				for(int x_line=0;x_line<4;x_line++)
					object[i].oldtrans[y_line][x_line]=object[i].trans[y_line][x_line];  
			object[i].b_first=false;//ó ƴϴ.

			// ID  ٸ ׸ ׸.
			click.x *= X_SCALE;
			click.y *= Y_SCALE;

			resize_image(blob_image,extension_image,xsize,ysize,X_SCALE,Y_SCALE);
			draw( object[i].model_id, object[i].trans,extension_image,click,finger_count,max_blob);
			break;
			frame_count=0;

		}
		//object[i].b_first==false ʿ ѹ̶ ;  ǥ ׸ 
		else if(object[i].b_first==false && frame_count<MAX_FRAME_COUNT){
			//draw( object[i].model_id, object[i].oldtrans ,blob_image,click,finger_count,max_blob);   
		}  
		else{

		}
	}    

	argSwapBuffers();//  ϰ ۸ üѴ.		

	//memory free
	free(hsi_image);	
	free(ycbcr_image);	
	free(rgb_image);
	free(color_or_image);
	free(blob_image); 	
	free(blob_image2); 
	free(contour_image); 	
	free(erosion_image);
	free(dilation_image);			
	free(input);
	free(extension_image);
}


// ============================================================================
//        draw
// -  gluProject gluUnProject Լ ̿  ǥ openglǥ ȯ
//
//
//*************gluProject Լ ****************
//
//gluProject  ( 
//GLdouble objX , GLdouble objY , GLdouble objZ , 
//const GLdouble *model , const GLdouble *proj , 
//const GLint *view , GLdouble* winX , GLdouble* winY , GLdouble* winZ );

//
//*************gluuNProject Լ ****************
//
//gluUnProject(GLdouble winx,GLdouble winy,GLdouble winz,
//const GLdouble modelMatrix[],const GLint viewport[],
//GLdouble *objx,GLdouble *objy,GLdouble *objz);
//
// ============================================================================
static int my_rotate = 0;
static int rotate_flag=0;

typedef struct{
	double x,y,z;
	float color_red;
	float color_green;
	float color_blue;
	int s_mode;
}OBJECT;

OBJECT objs[10000];
int obj_count=0;

int last_count;//Ŭ üũ ؾδ.


//    
typedef enum E_mode{SKETCH,COLOR,CHARACTER,PIANO};
typedef enum S_mode{NO,SPHERE,CONE,TORUS,ERASER,SPRING,SUMMER,FALL,WINTER};

E_mode  e_mode;
S_mode  s_mode;

// ׷ 
float color_red=0;
float color_green=0;
float color_blue=0;

//ǾƳ
bool bool_piano=false;
bool bool_character=false;

static void   draw( int object_id, double trans[3][4],ARUint8 * blob_image,point click,int finger_count,int max_blob)
{
	
	double    gl_para[16];
	int i,j;

	//ֺ - ü  
	GLfloat   mat_ambient[]     = {1.0f, 1.0f, 1.0f, 1.0f};
	// ۺ . current_object id 2  Ѵ.
	/*
	GLfloat   mat_flash[]       = {0.0, 0.0, 1.0, 1.0};
	GLfloat   mat_flash_shiny[] = {50.0};
	GLfloat   light_position[]  = {100.0,-200.0,200.0,0.0};
	GLfloat   ambi[]            = {0.1, 0.1, 0.1, 0.1};
	GLfloat   lightZeroColor[]  = {0.9, 0.9, 0.9, 0.1};
	int i;
	*/


	//glDepthFunc(GL_LESS);			// The Type Of Depth Test To Do    
	glShadeModel(GL_SMOOTH);


	////////////////////////////////////ٽ	////////////////////////////////////

	glPushMatrix();
	//argDrawMode2D();  ٽ ؼ װ   
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, xsize*X_SCALE, 0, ysize*Y_SCALE, -1.0, 1.0);
	glViewport(0, 0, xsize*X_SCALE,ysize*Y_SCALE);	

	//ٽ 
	glEnable(GL_STENCIL_TEST);	
	glClearStencil(0.0f);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_STENCIL);    
	glClear(GL_STENCIL_BUFFER_BIT);

	// ׷  ٽ ۸  ̴.
	//blob  ̹ شϴ κ ´.
	//׷ κ opengl ׷ ʴ´.
	glStencilFunc(GL_NEVER, 0x0, 0x0);
	glStencilOp(GL_INCR, GL_INCR, GL_INCR);	
	int y,x;
	unsigned long index;

	for(y=0;y<ysize*Y_SCALE;y++){
		for(x=0;x<xsize*X_SCALE;x++){			
			index=y*xsize*X_SCALE*BPP+x*BPP;
			if(blob_image[index]==0){
				
				glBegin( GL_POINTS );//vertex   ´.		
				glVertex3d( x,(ysize*Y_SCALE)-y, 0.0 );
				glEnd();
			}
		}
	}

	glStencilFunc(GL_NOTEQUAL, 0x1, 0x1);
	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	glPopMatrix();


	///////////////////////3d ʱȭ!//////////////////////////////
	argDrawMode3D();	
	glClearDepth( 1.0 );
	glClear(GL_DEPTH_BUFFER_BIT);
	glEnable(GL_DEPTH_TEST);//   	
	glEnable(GL_CCW);//ݽð  ε
	glDepthFunc(GL_LEQUAL);	

	/* load the camera transformation matrix */
	argConvGlpara(trans, gl_para);//artoolkit  openGL ķ .
	glMatrixMode(GL_MODELVIEW);
	glLoadMatrixd( gl_para );	

	//////////////////////  ϵ //////////////////
	/* 
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);


	//ֺ ϵ    
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,mat_ambient);
	// Ʈŷ ϵ 
	glEnable(GL_COLOR_MATERIAL);
	// ո鿡 ֺ л걤 ȿ  
	//л걤 â ġ ޺   ֺ л걤  .
	glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambi);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, lightZeroColor);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_flash);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_flash_shiny); 
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	*/ 

	glViewport(0,0,xsize*X_SCALE,ysize*Y_SCALE);

	////////////////////  marker ġ  ̵  /////////////////
	int translate_x=0,translate_y=0,translate_z=0;
	int t_temp=90;// Ŀ  Ÿ ϴٸ ̰ ؼ ƼĿ 

	switch( object_id ) {
		case 1:	translate_x=t_temp; translate_y=-t_temp;translate_z=0; break;
		case 2:	translate_x=-t_temp;translate_y=t_temp; translate_z=0; break;	
		default: break;
	}

	///////////////////////////////////////// ü ޴/////////////////////////////////////////////// 
	glPushMatrix();
	glTranslatef(translate_x,translate_y,translate_z);     


	//հ 3̸ ȸ
	if(max_blob>MAX_BLOB){
		if(finger_count == 3)		
			//if(finger_count ==1 && last_count ==3)		
			rotate_flag=1;
		//printf("հ  %d\n\n",count);
	}

	if(rotate_flag==1){										
		my_rotate+=10;
		if(my_rotate==360)
			my_rotate=0;				
	}

	if(my_rotate%90 ==0){
		rotate_flag=0;
	}

	//    
	if(my_rotate == 0)		 e_mode = SKETCH;
	else if(my_rotate == 90) e_mode = COLOR;
	else if(my_rotate == 180)e_mode = CHARACTER;
	else if(my_rotate == 270)e_mode = PIANO;

	glRotated(my_rotate,0,1,0);				

	float menu_size=60;

	////////////////////////////////   ////////////////////////////////
	glEnable(GL_TEXTURE_2D);			// Enable Texture Mapping

	glBindTexture(GL_TEXTURE_2D, texture[1]);   // choose the texture to use.	

	glBegin(GL_QUADS);		                // begin drawing a cube

	// Front Face (note that the texture's corners have to match the quad's corners)
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-menu_size, -menu_size,  menu_size);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( menu_size, -menu_size,  menu_size);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( menu_size,  menu_size,  menu_size);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-menu_size,  menu_size,  menu_size);	// Top Left Of The Texture and Quad
	glEnd();                                    // done with the polygon.

	glBindTexture(GL_TEXTURE_2D, texture[2]);   // choose the texture to use.

	glBegin(GL_QUADS);		                // begin drawing a cube
	// Back Face
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-menu_size, -menu_size, -menu_size);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-menu_size,  menu_size, -menu_size);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f( menu_size,  menu_size, -menu_size);	// Top Left Of The Texture and Quad
	glTexCoord2f(0.0f, 0.0f); glVertex3f( menu_size, -menu_size, -menu_size);	// Bottom Left Of The Texture and Quad
	glEnd();                                    // done with the polygon.

	glBindTexture(GL_TEXTURE_2D, texture[0]);   // choose the texture to use.

	glBegin(GL_QUADS);		                // begin drawing a cube
	// Top Face
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-menu_size,  menu_size, -menu_size);	// Top Left Of The Texture and Quad
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-menu_size,  menu_size,  menu_size);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f( menu_size,  menu_size,  menu_size);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( menu_size,  menu_size, -menu_size);	// Top Right Of The Texture and Quad
	glEnd();                                    // done with the polygon.

	glBindTexture(GL_TEXTURE_2D, texture[5]);   // choose the texture to use.

	glBegin(GL_QUADS);		                // begin drawing a cube
	// Bottom Face       
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-menu_size, -menu_size, -menu_size);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f( menu_size, -menu_size, -menu_size);	// Top Left Of The Texture and Quad
	glTexCoord2f(0.0f, 0.0f); glVertex3f( menu_size, -menu_size,  menu_size);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-menu_size, -menu_size,  menu_size);	// Bottom Right Of The Texture and Quad
	glEnd();                                    // done with the polygon.

	glBindTexture(GL_TEXTURE_2D, texture[4]);   // choose the texture to use.

	glBegin(GL_QUADS);		                // begin drawing a cube
	// Right face
	glTexCoord2f(1.0f, 0.0f); glVertex3f( menu_size, -menu_size, -menu_size);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f( menu_size,  menu_size, -menu_size);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f( menu_size,  menu_size,  menu_size);	// Top Left Of The Texture and Quad
	glTexCoord2f(0.0f, 0.0f); glVertex3f( menu_size, -menu_size,  menu_size);	// Bottom Left Of The Texture and Quad
	glEnd();                                    // done with the polygon.

	glBindTexture(GL_TEXTURE_2D, texture[3]);   // choose the texture to use.

	glBegin(GL_QUADS);		                // begin drawing a cube
	// Left Face
	glTexCoord2f(0.0f, 0.0f); glVertex3f(-menu_size, -menu_size, -menu_size);	// Bottom Left Of The Texture and Quad
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-menu_size, -menu_size,  menu_size);	// Bottom Right Of The Texture and Quad
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-menu_size,  menu_size,  menu_size);	// Top Right Of The Texture and Quad
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-menu_size,  menu_size, -menu_size);	// Top Left Of The Texture and Quad

	glEnd();                                    // done with the polygon.

	glPopMatrix();
	glDisable(GL_TEXTURE_2D);			// Enable Texture Mapping



	///////////////////////////////////////// Ŀ z ǥ /////////////////////////////////////////////// 		


	// 簢 ǥ  ȼ оð̴.
	GLdouble winX,winY,winZ;
	GLdouble winX1,winY1,winZ1;
	GLdouble winX2,winY2,winZ2;
	GLdouble winX3,winY3,winZ3;

	GLdouble objX,objY,objZ;

	GLdouble modelView_mat[16];
	GLdouble projection_mat[16];
	GLint    viewport_mat[4];		

	glGetDoublev(GL_MODELVIEW_MATRIX,  modelView_mat);
	glGetDoublev(GL_PROJECTION_MATRIX, projection_mat);
	glGetIntegerv(GL_VIEWPORT,         viewport_mat);

	//Ŀ Zǥ
	//Ŀ ϴ 4  
	double glu_z=0;	
	glPushMatrix();
	glTranslatef(translate_x,translate_y,translate_z);
	gluProject(-menu_size ,  -menu_size   ,  0.0f,modelView_mat,projection_mat,viewport_mat,&winX ,&winY ,&winZ); 
	gluProject( menu_size ,  -menu_size   ,  0.0f,modelView_mat,projection_mat,viewport_mat,&winX ,&winY ,&winZ1); 
	gluProject( menu_size ,   menu_size   ,  0.0f,modelView_mat,projection_mat,viewport_mat,&winX ,&winY ,&winZ2); 
	gluProject(-menu_size ,   menu_size   ,  0.0f,modelView_mat,projection_mat,viewport_mat,&winX ,&winY ,&winZ3); 
	glu_z=(winZ+winZ1+winZ2+winZ3)/4;	
	glPopMatrix();




	///////////////////////////////////////////޴ Ŭ  ///////////////////////////////////////////////
	int menu_click=0;
	static bool all_flag;
	all_flag=false;

	if(finger_count == 1 && last_count == 2 && (my_rotate%90 ==0) ){
		
		//if(finger_count == 2 && (my_rotate%90 ==0) ){
		int flag1,flag2,flag3,flag4;			
		point a,b,c,d;
		//4 ޴ ݺ
		for(i=0;i<4;i++){

			gluProject(-menu_size + translate_x,   menu_size/5   - i*menu_size/5*2 + translate_y,  menu_size,modelView_mat,projection_mat,viewport_mat,&winX ,&winY ,&winZ); 
			gluProject( menu_size + translate_x,   menu_size/5   - i*menu_size/5*2 + translate_y,  menu_size,modelView_mat,projection_mat,viewport_mat,&winX1,&winY1,&winZ1); 
			gluProject( menu_size + translate_x,   menu_size/5*3 - i*menu_size/5*2 + translate_y,  menu_size,modelView_mat,projection_mat,viewport_mat,&winX2,&winY2,&winZ2);
			gluProject(-menu_size + translate_x,   menu_size/5*3 - i*menu_size/5*2 + translate_y,  menu_size,modelView_mat,projection_mat,viewport_mat,&winX3,&winY3,&winZ3);

			a.x = winX;	  a.y = winY;
			b.x = winX1;  b.y = winY1;
			c.x = winX2;  c.y = winY2;
			d.x = winX3;  d.y = winY3;

			//4 ޴ Ʈȿ Ŭ ǥ Դ°?				
			flag1 = ccw(a,b,click);
			flag2 = ccw(b,c,click);
			flag3 = ccw(c,d,click);
			flag4 = ccw(d,a,click);

			//Ŭ ޴ 簢 ׸
			if(flag1 == 1 && flag2 == 1 && flag3 == 1 && flag4 == 1){
				all_flag=true;
				//޴ Ŭ Ҹ
				mix(9);
				menu_click = 1;
				switch(e_mode){
					case SKETCH:{
							switch(i){
								case 0:
									{
										s_mode = SPHERE;
										mix (10);
										break;
									}
								case 1:
									{
										s_mode = CONE;  
										mix (11);
										break;
									}
								case 2:
									{
										s_mode = TORUS; 
										mix (12);
										break;
									}
								case 3:
									{
										mix (13);
										s_mode = ERASER;
										break;
									}
							}
						}
						break;
					case COLOR:{
							switch(i){
								//red, green, blue, black
								case 0: color_red   =1;color_green =0;color_blue  =0;mix (14);break;
								case 1:	color_red   =0;color_green =1;color_blue  =0;mix (15);break;
								case 2: color_red   =0;color_green =0;color_blue  =1;mix (16);break;
								case 3:	color_red   =0;color_green =0;color_blue  =0;mix (17);break;
							}				
						}
						break;
					case CHARACTER:{
							s_mode = NO;
							bool_character=!bool_character;
							bool_piano = false;	
							mix (19);
						}
						break;
					case PIANO:{
							s_mode = NO;
							bool_piano = !bool_piano;	
							bool_character = false;
							mix (18);
						}
					break;
				}			
				//Ŭ   ׸
				glColor3f(1,0,0);
				glBegin(GL_QUADS);				
				glVertex3f(-menu_size + translate_x,  menu_size/5  - i*menu_size/5*2 + translate_y,  menu_size+1);
				glVertex3f( menu_size + translate_x,  menu_size/5  - i*menu_size/5*2 + translate_y,  menu_size+1);				
				glVertex3f( menu_size + translate_x,  menu_size/5*3 - i*menu_size/5*2 + translate_y,  menu_size+1);
				glVertex3f(-menu_size + translate_x,  menu_size/5*3 - i*menu_size/5*2 + translate_y,  menu_size+1);
				glEnd();						

			}
		}		
	}
/*
	if(all_flag==false)
			mix (20);
*/



	//////////////////////////////////        ǾƳ         ///////////////////////////////////	

	int piano_width=200,piano_height=50;

	if(bool_piano == true){
		glPushMatrix();
		glTranslatef(translate_x,translate_y,translate_z); 
		glTranslatef(0,-150,0);
		glEnable(GL_TEXTURE_2D);		

		//
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, texture[6]);					
		glBegin(GL_QUADS);				
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-piano_width,-piano_height,  30.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( piano_width,-piano_height,  30.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( piano_width, piano_height,  30.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-piano_width, piano_height,  30.0f);					
		glEnd();					
		glDisable(GL_TEXTURE_2D);			

		//ϴ
		glBegin(GL_QUADS);
		glColor3f(1,1,1);
		glVertex3f(-piano_width,-piano_height,0.0f);
		glVertex3f( piano_width,-piano_height,0.0f);
		glVertex3f( piano_width, piano_height,0.0f);
		glVertex3f(-piano_width, piano_height,0.0f);										
		glEnd();					

		//ո
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, texture[7]);
		glBegin(GL_QUADS);										
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-piano_width,-piano_height, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( piano_width,-piano_height, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( piano_width,-piano_height, 30.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-piano_width,-piano_height, 30.0f);	
		glEnd();
		glDisable(GL_TEXTURE_2D);			

		//޸
		glBegin(GL_QUADS);
		glColor3f(1,1,1);
		glVertex3f(-piano_width, piano_height, 0.0f);
		glVertex3f( piano_width, piano_height, 0.0f);
		glVertex3f( piano_width, piano_height, 30.0f);
		glVertex3f(-piano_width, piano_height, 30.0f);	
		glEnd();

		//
		glBegin(GL_QUADS);
		glColor3f(1,1,1);
		glVertex3f(-piano_width, piano_height, 0.0f);
		glVertex3f(-piano_width,-piano_height, 0.0f);
		glVertex3f(-piano_width,-piano_height, 30.0f);
		glVertex3f(-piano_width, piano_height, 30.0f);	
		glEnd();

		//
		glBegin(GL_QUADS);
		glColor3f(1,1,1);
		glVertex3f( piano_width, piano_height, 0.0f);
		glVertex3f( piano_width,-piano_height, 0.0f);
		glVertex3f( piano_width,-piano_height, 30.0f);
		glVertex3f( piano_width, piano_height, 30.0f);	
		glEnd();

		//ǹ  ׽Ʈ
		int flag1,flag2,flag3,flag4;			
		point a,b,c,d;

		if(finger_count == 1 && last_count==2){			
			for(i=0;i<8;i++){
				glGetDoublev(GL_MODELVIEW_MATRIX,  modelView_mat);
				glGetDoublev(GL_PROJECTION_MATRIX, projection_mat);
				glGetIntegerv(GL_VIEWPORT,         viewport_mat);

				gluProject(-200+i*50,-50,31,modelView_mat,projection_mat,viewport_mat,&winX ,&winY ,&winZ); 
				gluProject(-150+i*50,-50,31,modelView_mat,projection_mat,viewport_mat,&winX1,&winY1,&winZ1); 
				gluProject(-150+i*50, 50,31,modelView_mat,projection_mat,viewport_mat,&winX2,&winY2,&winZ2);
				gluProject(-200+i*50, 50,31,modelView_mat,projection_mat,viewport_mat,&winX3,&winY3,&winZ3);

				a.x = winX;	  a.y = winY;
				b.x = winX1;  b.y = winY1;
				c.x = winX2;  c.y = winY2;
				d.x = winX3;  d.y = winY3;

				//4 ޴ Ʈȿ Ŭ ǥ Դ°?				
				flag1 = ccw(a,b,click);
				flag2 = ccw(b,c,click);
				flag3 = ccw(c,d,click);
				flag4 = ccw(d,a,click);					

				//Ŭ ޴ 簢 ׸
				if(flag1 == 1 && flag2 == 1 && flag3 == 1 && flag4 == 1){						
					glBegin(GL_QUADS);				
					glColor3d(1,0,0);
					glVertex3f( -200 + i*50, -50 , 31.0f);
					glVertex3f( -150 + i*50, -50 , 31.0f);
					glVertex3f( -150 + i*50,  50 , 31.0f);
					glVertex3f( -200 + i*50,  50 , 31.0f);	
					glEnd();
					//Ŭ ǹݿ  Ѵ.
					switch(i){
						case 0:	mix(0);	break;
						case 1:	mix(1);	break;
						case 2:	mix(2);	break;
						case 3:	mix(3);	break;
						case 4:	mix(4);	break;
						case 5:	mix(5);	break;
						case 6:	mix(6);	break;
						case 7:	mix(7);	break;
					}
				}
			}
		}
		glPopMatrix();
	}

	//ǾƳ밡  ׸ ׸  .
	if(menu_click==0 && bool_piano==false && bool_character==false){
		////////////////////////////////////////찳 /////////////////////////////////////
		glColor3f(0.5,0.5,0.8);
		int Erase_SIZE=40; 
		glPushMatrix();
		if(s_mode == ERASER){
			glTranslatef(translate_x,translate_y,translate_z); 
			objX=0;objY=0;objZ=0;			
			glGetDoublev(GL_MODELVIEW_MATRIX,  modelView_mat);
			glGetDoublev(GL_PROJECTION_MATRIX, projection_mat);
			glGetIntegerv(GL_VIEWPORT,         viewport_mat);

			if(click.x >0 && click.x <xsize*X_SCALE && click.y >0 && click.y <ysize*Y_SCALE){					
				gluUnProject(click.x,click.y,glu_z,modelView_mat,projection_mat,viewport_mat,&objX ,&objY ,&objZ);
				glTranslatef(objX ,objY, 0);
				glBegin(GL_QUADS);
				glVertex3f(-Erase_SIZE, -Erase_SIZE, 0.0f);	// Top Right Of The Texture and Quad
				glVertex3f( Erase_SIZE, -Erase_SIZE, 0.0f);	// Top Left Of The Texture and Quad
				glVertex3f( Erase_SIZE,  Erase_SIZE, 0.0f);	// Bottom Left Of The Texture and Quad
				glVertex3f(-Erase_SIZE,  Erase_SIZE, 0.0f);	// Bottom Right Of The Texture and Quad
				glEnd();

				// Ÿϸ  ǥ Ѵ.
				for(i=0;i<obj_count;i++){
					if(fabs(objs[i].x - objX ) < Erase_SIZE && fabs(objs[i].y - objY ) < Erase_SIZE){
						for(j=i;j<obj_count-1;j++)
						{
							objs[j]=objs[j+1];
						}
						obj_count--;
					}						
				}
			}
		}		
		glPopMatrix();


		//찳 尡 ƴҶ ǥ 
		if(s_mode != ERASER){
			/////////////////////////////////////Ŭ ǥ, ÷,  ////////////////////////////////////////
			// Ŀ  ߽ ̵Ͽ ǥ Ѵ.
			//׸ ׸ ߽ ̵Ͽ ׸.
			glPushMatrix();	
			glTranslatef(translate_x,translate_y,translate_z); 
			//if(finger_count == 2 && glu_z !=0){
			if((finger_count == 1 && last_count == 2 &&glu_z !=0) || (finger_count == 2 && s_mode == SPHERE))
			{				
				objX=0;objY=0;objZ=0;			
				glGetDoublev(GL_MODELVIEW_MATRIX,  modelView_mat);
				glGetDoublev(GL_PROJECTION_MATRIX, projection_mat);
				glGetIntegerv(GL_VIEWPORT,         viewport_mat);

				if(click.x >0 && click.x <xsize*X_SCALE && click.y>0 && click.y <ysize*Y_SCALE){
					//⼭ glu_z ſ ߿  Ѵ.  click ,ճ Ϳ  ǥ
					//UnProjectϸ.. װſ   ڸ  Ѱ ƴϱ  ε  
					// ʴ´. 
					if(s_mode != SPHERE)
						mix(20);

					//glu_z 0~1 Ǽ  .
					gluUnProject(click.x,click.y,glu_z,modelView_mat,projection_mat,viewport_mat,&objX ,&objY ,&objZ);	

					//ȭ 
					//gluUnProject(click.x,click.y,0,modelView_mat,projection_mat,viewport_mat,&objX ,&objY ,&objZ);
					if(objZ!=0){
						//Ʈ  line , squre , cone, sphere
						objs[obj_count].s_mode = s_mode;

						// 
						objs[obj_count].color_red = color_red;
						objs[obj_count].color_green = color_green;
						objs[obj_count].color_blue = color_blue;

						//ǥ					
						objs[obj_count].x=objX;
						objs[obj_count].y=objY;
						objs[obj_count++].z=0;//   ϰ .. ׸ Ȯ տ ȳ
						//ȭ 
						//objs[obj_count++].z=objZ;//   ϰ .. ׸ Ȯ տ ȳ
					}
				}
			}
			glPopMatrix();
			glDisable(GL_TEXTURE_2D);			// Enable Texture Mapping
		}


		///////////////////////////Ŭ ŭ Ʈ ׸/////////////////////////////////
		glPushMatrix();	
		glTranslatef(translate_x,translate_y,translate_z);   
		for(i=0;i<obj_count;i++)
		{				
			glPushMatrix();
			glColor3f(objs[i].color_red,objs[i].color_green,objs[i].color_blue);
			glTranslatef(objs[i].x,objs[i].y,objs[i].z);

			if(objs[i].s_mode == SPHERE)
				glutSolidSphere(10,15,15);																		
			else if(objs[i].s_mode == CONE)
				glutSolidCone(10,100,15,15);			
			else if(objs[i].s_mode == TORUS)				
				glutSolidTorus(5,15,15,15);
			glPopMatrix();
		}
		glPopMatrix();	
	}

	

	/////////////////////////////////////////////3d object/////////////////////////////////////////////
	//MD2 Loader 	
	if(bool_character==true){
		//  
		mix(8);

		glPushMatrix();	
		glTranslatef(translate_x,translate_y,translate_z);  
		
		static int kkk=0;
		

		static int n = 0; /* The current frame */
		static float interp = 0.0;
		static double curent_time = 0;
		static double last_time = 0;

		//glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		//glLoadIdentity ();

		last_time = curent_time;
		curent_time = (double)glutGet (GLUT_ELAPSED_TIME) / 1000.0;

		/* Animate model from frames 0 to num_frames-1 */
		interp += 10 * (curent_time - last_time);  

		
		//stand
		if(finger_count==1)
			Animate (0, 39, &n, &interp);	
		//run
		else if(finger_count==2)
			Animate (40, 45, &n, &interp);	
		//jump
		else if(finger_count==3)
			Animate (66, 71, &n, &interp);	
		//stand
		else
			Animate (0, 39, &n, &interp);	
		
		glTranslatef (200.0f, 0.0f, -100.0f);	

		//move
		glTranslatef(kkk++,0,0);
		if(kkk==50)
			kkk=0;

		glRotatef (-90.0f, 0.0, 0.0, 1.0);
		glScalef(10,10,10);
		
		//n شϴ  ش.
		RenderFrame(n, interp);

		glPopMatrix();		
	}	
	else{
		//  off
		mix_off(7);
	}

	last_count = finger_count;//콺 Ŭ üũ ؼ	

	

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );
}